require "import"
import "android.widget.*"
import "java.io.BufferedWriter"
import "java.io.FileWriter"
import "java.io.IOException"
import "android.content.Context"
import "android.content.Intent"
import "java.util.Locale"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"

local file_path = "/storage/emulated/0/解说/Plugins/Voice caller 1.0/Contact.lua"

-- Check if the file exists
local file = io.open(file_path, "r")
if file then
-- File exists
file:close()
local numberTable = dofile("/storage/emulated/0/解说/Plugins/Voice caller 1.0/Contact.lua")
function co()
require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.content.Intent"
import "android.content.Context"

local Symbol={}
local path=this.getLuaExtDir("Plugins").."/Voice caller 1.0/Contact.lua"

---读取符号文件函数
local function readSymbol(t,path)
	local file,eor=io.open(path,"r")
	if eor~=nil then
		file,eor=io.open(path,"w")
	end
	
	local s
	for line in io.lines(path) do
		s=string.gsub(line,'\\n','\n')
		s= s=="\\\\" and "\\" or s
		table.insert(t,s)
	end
	file:close()
end

---写入符号函数
local function writeSymbol(t,path)
	file=io.open(path,'w')
	for _,v in ipairs(t) do
		v= v=="\\" and "\\\\" or v
		file:write(string.gsub(v,'\n','\\n')..'\n')
	end
	file:close()
end

---移动函数
local function moveItem(t,k,itemKey)
	local s=t[k+1]
	if itemKey==0 and k>5 then
		table.insert(t,k-5,s)
		table.remove(t,k+2)
		elseif itemKey==1 and #t-k>=7 then
		table.insert(t,k+8,s)
		table.remove(t,k+1)
		elseif itemKey==2 and k>0 then
		t[k],t[k+1]=t[k+1],t[k]
		elseif itemKey==3 and k+1<#t then
		t[k+1],t[k+2]=t[k+2],t[k+1]
		elseif itemKey==4 then
		table.remove(t,k+1)
	end
end

---编辑框界面
local edit=loadlayout({
	EditText;
	hint="you can enter symbols or phrases more than one line!. "
})
local et=LuaDialog()
et.setTitle("Add")
et.setView(edit)
et.setButton("ok",function()
	if edit.text~='' then
		table.insert(Symbol,edit.text)
		edit.text=''
		writeSymbol(Symbol,path)
	end
	--重新载入符号表
	grid.adapter=SingleLineAdapter(service,String(Symbol))
	dlg.show()
end)

---说明界面
local readme=LuaDialog(service)
readme.setTitle("description")
readme.setMessage("This is a favorite where we can put icons or phrases. \nVersion：V1.0 \nDeveloper：coolsnowbye\n translated by Balakrishnan")

readme.setButton("close",function()

	dlg.show()
end)

---长按菜单
local menuItem=
{
	"move element up",
	"move element down",
	"move element left",
	"move element to the right",
	"delete",
}
local menuDlg=LuaDialog(service)
--menuDlg.setTitle("menu")
menuDlg.setItems(menuItem)

---主界面
layout={
	GridView,
	id="grid",
	numColumns=0,
	layout_width="fill",
background = "#000000"; -- black color code
	layout_height="fill"
}

dlg=LuaDialog(service)
dlg.View=loadlayout(layout)
readSymbol(Symbol,path)
grid.adapter=SingleLineAdapter(service,String(Symbol))
dlg.setButton("close")
	task(50,function()
end)
dlg.setButton3("description",function(v)
	readme.show()
end)

dlg.show()
grid.onItemClick=function(l,v)
	dlg.dismiss()
	service.pasteText(node,v.text)
	service.speak(v.text)
	return true
end

grid.onItemLongClick=function(l,v,p,i)
	dlg.dismiss()
	vibrator = this.getSystemService(Context.VIBRATOR_SERVICE)
	vibrator.vibrate( long{50,30} ,-1)
	menuDlg.show()
	menuDlg.onItemClick=function(_,_,itemKey)
		menuDlg.dismiss()
		moveItem(Symbol,i,itemKey)
		writeSymbol(Symbol,path)
		--重新载入符号表
		grid.adapter=SingleLineAdapter(service,String(Symbol))
		dlg.show()
	end

end
end
function s()
function pn()
local answerText = answer.text
local s = answerText:gsub("^%s*(.-)%s*$", "%1")
local name = s
local contact = numberTable[name]
if contact then
print(name)
print(contact)
else
end
end
function voice()
local substitutionTable = {   
    ["chino"] = "Jieshuo"   
}   

function hasInternetConnection()   
    local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)   
    local networkInfo = connectivityManager.getActiveNetworkInfo()   
    return networkInfo ~= nil and networkInfo.isConnected()   
end   

function kill()   
    speechRecognizer.destroy()   
    speechRecognizer = nil   
    return true   
end   

function startListening()   
    if not hasInternetConnection() then   
        service.asyncSpeak("இணைய இணைப்பு இல்லை.இணைய இணைப்பை சரி பார்த்த பிறகு  மீண்டும் முயலவும்.")   
        return false   
    end   

    local verbalizationDetected = false   

    speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)   

    speechListener = RecognitionListener{   
        onResults = function(results)   
            data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)   
            if data ~= nil and data.size() > 0 then   
                verbalizationDetected = true   
                local recognizedText = data.get(0)   
                local node = service.getEditText()   
                local editText = service.getText(node)   

                if editText and string.len(editText) > 0 then   
                    recognizedText = " " .. recognizedText   
                end   

                recognizedText = string.gsub(recognizedText, "(%s?ஸ்டார்)(%s?)([%p]*)$", "%2*%3")   
                recognizedText = string.gsub(recognizedText, "(%s?)சிம்பல்(%s?)([%p]*)$", "%2#%3")   

                service.insertText(node, recognizedText)   
                service.speak(recognizedText)   
            end   

            if not verbalizationDetected then   
                kill()   
                return false   
            end   
        end,   
        onError = function()   
            kill()   
            return false   
        end   
    }   

    recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)   
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)   
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ta_IN")   
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())   

    speechRecognizer.startListening(recognizerIntent)   
    speechRecognizer.setRecognitionListener(speechListener)   

    return true   
end   
startListening()   
return true
end
--voice function முடிவு
layout = {
    LinearLayout;
    orientation = "vertical";
background = "#000000"; -- black color code
    {
        TextView;
        text = "Save Contact";
        layout_gravity = "center_horizontal";
        textSize = "20sp";
        paddingTop = "20dp";
        paddingBottom = "20dp";
    };
    {
        EditText;
        hint = "name";
        id = "answer";
        inputType = "text";
        layout_width = "match_parent";
        layout_height = "wrap_content";
        onLongClickListener = {
            onLongClick = function(view)
voice()
                return true
            end
        };
    };
    {
        EditText;
        hint = "mobile number";
        id = "editText";
        inputType = "number";
        layout_width = "match_parent";
        layout_height = "wrap_content";
onLongClickListener = {
onLongClick = function(view)
voice()
return true
end
};
    };
    {
        Button;
        text = "OK";
textColor="#ff00ff00",
background = "#000000"; -- black color code
textSize="40sp",
layout_width = "match_parent";
layout_height = "wrap_content";
onLongClickListener = {
onLongClick = function(view)
pn()
return true
end
};
        onClick = function()
local answerText = answer.text
if answerText == "" then
service.speak("பெயரை உள்ளிடவும்")
else
local s = answerText:gsub("^%s*(.-)%s*$", "%1")
local name = s
local contact = numberTable[name]
if contact then
service.speak("ஏற்கனவே சேமிக்கப்பட்ட பெயர். வேறு பெயரில் சேமிக்கவும்")
else
            local answerText = answer.text
            local c = answerText:gsub("%,", "")
            local d = c:gsub("%.", "")
            local trimmedAnswerText = d:gsub("^%s*(.-)%s*$", "%1")
            local modifiedText = "[\"" .. trimmedAnswerText .. "\"] = "
            local editTextText = editText.text
if editTextText == "" then
service.speak("தொலைபேசி எண்களை உள்ளிடவும்")
else
            local trimmedEditTextText = editTextText:gsub("%s", "")
            local modifiedEditTextText = "\"" .. trimmedEditTextText .. "\",\n"
            
            -- Save result to a file
            local filepath = "/storage/emulated/0/解说/Plugins/Voice caller 1.0/Contact.lua"
            local file, error = io.open(filepath, "r")
            if file == nil then
                print("Error opening file: " .. error)
                dlg.dismiss()
                return
            end
            
            -- Read existing content from the file
            local content = file:read("*a")
            file:close()
            
            -- Insert the modifiedText and modifiedEditTextText in the second line
            content = content:gsub("\n", "\n" .. modifiedText .. modifiedEditTextText, 1)
            
            -- Write the modified content back to the file
            file, error = io.open(filepath, "w")
            if file == nil then
                print("Error opening file: " .. error)
                dlg.dismiss()
                return
            end
            
            file:write(content)
            file:close()
            
            answer.text = ""
            editText.text = ""
            
            service.speak("தொடர்பு சேமிக்கப்பட்டது")
end
end
end
        end;
};
{
Button;
text = "contacts";
textColor="#ffffff",
background = "#000000"; -- black color code
textSize="40sp",
layout_width = "match_parent";
layout_height = "wrap_content";
onClick = function()
co()
end
};
{
Button;
text = "close";
textColor="#ff0000",
background = "#000000"; -- black color code
textSize="40sp",
layout_width = "match_parent";
layout_height = "wrap_content";
onClick = function()
service.click({{"%Go back",}})
end
};
}
dlg = LuaDialog(service)
dlg.View = loadlayout(layout)
dlg.show()
end
--s function முடிவு

function hasInternetConnection()
local connectivityManager = this.getSystemService(Context.CONNECTIVITY_SERVICE)
local networkInfo = connectivityManager.getActiveNetworkInfo()
return networkInfo ~= nil and networkInfo.isConnected()
end

function startListening()
if not hasInternetConnection() then
  service.speak("இணைய இணைப்பை சரி பார்க்கவும்")
  return false
end

local verbalizationDetected = false
local recognizedName = ""

speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)

speechListener = RecognitionListener{
  onResults = function(results)
    data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
    if data ~= nil and data.size() > 0 then
      verbalizationDetected = true
      recognizedName = data.get(0)

      local number = numberTable[recognizedName]
      if number ~= nil then
        service.callPhone(number)
        return true
       else
s()
        end
      end
    end
  }

  recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
  recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
  recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ta_IN")
  recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())

  speechRecognizer.startListening(recognizerIntent)
  speechRecognizer.setRecognitionListener(speechListener)

  return true
end

startListening()
return true
else
-- File does not exist
local sourceFile = '/storage/emulated/0/解说/Plugins/Voice caller 1.0/Empty.txt'
local targetFile = '/storage/emulated/0/解说/Plugins/Voice caller 1.0/Contact.lua'

-- Open the source file in read mode
local source = io.open(sourceFile, 'r')
if not source then
    print('Failed to open source file:', sourceFile)
    return
end

-- Read the content of the source file
local content = source:read('*all')

-- Close the source file
source:close()

local target = io.open(targetFile, 'w')
if not target then
print('Failed to open target file:', targetFile)
return
end

-- Write the content to the target file
target:write(content)

-- Close the target file
target:close()

        layout = {
          LinearLayout;
          orientation = "vertical";

}
          dlg = LuaDialog(service)
dlg.setButton("cancel",nil)
dlg.setTitle("பூபாலன் பாலகிருஷ்ணன் உருவாக்கிய நீட்டிப்பிற்கு தங்களை அன்புடன் வரவேற்கிறோம்")
          dlg.View = loadlayout(layout)
          dlg.show()
end